//******************************************************************************
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    AUTHOR SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//    PROGRAM ZAWARTY W TYM PLIKU PRZEZNACZONY JEST WYLACZNIE
//    DO CELOW SZKOLENIOWYCH. AUTOR NIE PONOSI ODPOWIEDZIALNOSCI
//    ZA ZADNE EWENTUALNE, BEZPOSREDNIE I POSREDNIE SZKODY
//    WYNIKLE Z JEGO WYKORZYSTANIA.
//******************************************************************************

#include "stm32f1xx_hal.h"
#include "kb4x4_lib.h"

const char kbKeyMap[4][4]={{KB4x4_R1C1, KB4x4_R1C2, KB4x4_R1C3, KB4x4_R1C4},
                           {KB4x4_R2C1, KB4x4_R2C2, KB4x4_R2C3, KB4x4_R2C4},
                           {KB4x4_R3C1, KB4x4_R3C2, KB4x4_R3C3, KB4x4_R3C4},
                           {KB4x4_R4C1, KB4x4_R4C2, KB4x4_R4C3, KB4x4_R4C4}};
const char kbRows[4]={KB4x4_R1, KB4x4_R2, KB4x4_R3, KB4x4_R4};
const char kbCols[4]={KB4x4_C1, KB4x4_C2, KB4x4_C3, KB4x4_C4};

void KB4x4_Config(void)
{
  GPIO_InitTypeDef GPIO_InitStruct;

  if (KB4x4_GPIO == GPIOA) __HAL_RCC_GPIOA_CLK_ENABLE(); else
  if (KB4x4_GPIO == GPIOB) __HAL_RCC_GPIOB_CLK_ENABLE(); else
  if (KB4x4_GPIO == GPIOC) __HAL_RCC_GPIOC_CLK_ENABLE(); else
  if (KB4x4_GPIO == GPIOD) __HAL_RCC_GPIOD_CLK_ENABLE(); else
  if (KB4x4_GPIO == GPIOE) __HAL_RCC_GPIOE_CLK_ENABLE();


  GPIO_InitStruct.Pin = KB4x4_R1 | KB4x4_R2 | KB4x4_R3 | KB4x4_R4;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(KB4x4_GPIO, &GPIO_InitStruct);


  GPIO_InitStruct.Pin = KB4x4_C1 | KB4x4_C2 | KB4x4_C3 | KB4x4_C4;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_PULLDOWN;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(KB4x4_GPIO, &GPIO_InitStruct);

}


char KB4x4_ReadKey(void)
{ //returns ASCII code of a pressed key
  unsigned char r, c;
  char pressedKey=0x00;

  r=0;
  while (r<4) {
    HAL_GPIO_WritePin(KB4x4_GPIO, kbRows[r], GPIO_PIN_SET);        //activate row
    c=0;
    while (c<4) {
      if (HAL_GPIO_ReadPin(KB4x4_GPIO, kbCols[c])==GPIO_PIN_SET){  //check columns
        pressedKey=kbKeyMap[r][c];                                 //if column active - find key value
      }
      c++;
    }
    HAL_GPIO_WritePin(KB4x4_GPIO, kbRows[r], GPIO_PIN_RESET);      //deactivate row
    r++;
  }
  return pressedKey;                                               //return ASCII key value
}
