//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    AUTHOR SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************


#define SSD1331_SPI  SPI1
#define SSD1331_SPI_GPIO GPIOA     //SSD1331 GPIO port for SPI
                                
#define SSD1331_SS   GPIO_PIN_4    //SPI SS  (CS)
#define SSD1331_SCK  GPIO_PIN_5    //SPI SCK (SCL)
#define SSD1331_MOSI GPIO_PIN_7    //SPI MOSI (DIN)
#define SSD1331_DC   GPIO_PIN_8    //        (D/C)
#define SSD1331_RES  GPIO_PIN_9    //        (RES)


#define SSD1331_CMD                            0
#define SSD1331_DATA                           1

#define SSD1331_OLED_WIDTH                      96
#define SSD1331_OLED_HEIGHT                     64

//Drawing acceleration commands
#define SSD1331_DRAW_LINE                       0x21
#define SSD1331_DRAW_RECTANGLE                  0x22
#define SSD1331_COPY_WINDOW                     0x23
#define SSD1331_DIM_WINDOW                      0x24
#define SSD1331_CLEAR_WINDOW                    0x25
#define SSD1331_FILL_EN                         0x26
#define SSD1331_DISABLE_FILL                    0x00
#define SSD1331_ENABLE_FILL                     0x01
#define SSD1331_CONTINUOUS_SCROLLING_SETUP      0x27
#define SSD1331_DEACTIVE_SCROLLING              0x2E
#define SSD1331_ACTIVE_SCROLLING                0x2F

//Command codes
#define SSD1331_SET_COLUMN_ADDRESS              0x15
#define SSD1331_SET_ROW_ADDRESS                 0x75
#define SSD1331_SET_CONTRAST_A                  0x81
#define SSD1331_SET_CONTRAST_B                  0x82
#define SSD1331_SET_CONTRAST_C                  0x83
#define SSD1331_MASTER_CURRENT_CONTROL          0x87
#define SSD1331_SET_PRECHARGE_SPEED_A           0x8A
#define SSD1331_SET_PRECHARGE_SPEED_B           0x8B
#define SSD1331_SET_PRECHARGE_SPEED_C           0x8C
#define SSD1331_SET_REMAP                       0xA0
#define SSD1331_SET_DISPLAY_START_LINE          0xA1
#define SSD1331_SET_DISPLAY_OFFSET              0xA2
#define SSD1331_NORMAL_DISPLAY                  0xA4
#define SSD1331_ENTIRE_DISPLAY_ON               0xA5
#define SSD1331_ENTIRE_DISPLAY_OFF              0xA6
#define SSD1331_INVERSE_DISPLAY                 0xA7
#define SSD1331_SET_MULTIPLEX_RATIO             0xA8
#define SSD1331_DIM_MODE_SETTING                0xAB
#define SSD1331_SET_MASTER_CONFIG               0xAD
#define SSD1331_DISPLAY_ON_DIM                  0xAC
#define SSD1331_DISPLAY_OFF                     0xAE
#define SSD1331_DISPLAY_ON_NORMAL               0xAF
#define SSD1331_POWER_SAVE_MODE                 0xB0
#define SSD1331_PHASE_PERIOD_ADJUSTMENT         0xB1
#define SSD1331_DISPLAY_CLOCK_DIV               0xB3
#define SSD1331_SET_GRAY_SCALE_TABLE            0xB8
#define SSD1331_ENABLE_LINEAR_GRAY_SCALE_TABLE  0xB9
#define SSD1331_SET_PRECHARGE_VOLTAGE           0xBB
#define SSD1331_SET_V_VOLTAGE                   0xBE


#define RGB565(R,G,B)  (((R >> 3) << 11) | ((G >> 2) << 5) | (B >> 3))   //color conversion from standard 888RGB to 565RGB


void SSD1331_SPI_HwConfig();
void SSD1331_SPI_Init();
void SSD1331_SPI_WriteByte(unsigned char v, unsigned char DC);

void SSD1331_ClearScreen();
void SSD1331_DrawPixel(unsigned char x, unsigned char y, unsigned short int color);
void SSD1331_DrawLine(unsigned char x0, unsigned char y0, unsigned char x1, unsigned char y1, unsigned short int lineColor);
void SSD1331_FillRect(unsigned char x0, unsigned char y0, unsigned char x1, unsigned char y1, unsigned short int fillColor, unsigned short int lineColor);
void SSD1331_DrawCircle(int x0, int y0, int radius, unsigned int color);
void SSD1331_FillCircle(int x0, int y0, int radius, unsigned int color);
void SSD1331_WriteTextXY(const char *text, int xs, int ys, unsigned int fontColor, unsigned int bkgColor, const unsigned char * FontData);
void SSD1331_Write565Bitmap(const unsigned char *buffer, int xPos, int yPos, int xSize, int ySize);
